sub init()
    print "INIT: ChannelGridPanel"
    
    m.top.panelSize = "medium"
    m.top.focusable = true
    m.top.hasNextPanel = true
    m.top.leftOnly = false
    m.top.goBackCount = 1
    
    m.top.createNextPanelOnItemFocus = false
    m.top.selectButtonMovesPanelForward = false

    m.top.grid = m.top.FindNode("ChannelsGrid")
    
    m.top.leftLabel.font = m.global.fonts.regular18
    m.top.leftLabel.color = m.global.color.highlight
    m.top.rightLabel.font = m.global.fonts.regular18
    m.top.rightLabel.color = m.global.color.text2
end sub
'******************************************************
sub GetChannels()
    print "...Get Channels"
    m.global.loading = true
    SetLoadingContent()
    m.request = createObject("roSGNode","GetRequest")
    url = ""
    if(m.top.genreId = -1)
        url = m.global.apipath+m.global.apiname+"/tv/ws/Channel?deviceId=1&id=0&active=true&sessionId="+m.global.sessionId
    else
        url = m.global.apipath+m.global.apiname+"/tv/ws/Channel?deviceId=1&id=0&active=true&genreId="+m.top.genreId.tostr()+"&sessionId="+m.global.sessionId
    endif
    m.request.uri = url 'm.global.apipath+m.global.apiname+"/tv/ws/Channel?deviceId=1&id=0&active=true&sessionId="+ m.global.sessionId
    m.request.observeField("content","OnChannels")
    m.request.control = "RUN"
end sub

sub OnChannels()
    print "OnChannels: "';m.request.content
    json = ParseJSON(m.request.content)
    if(json<>invalid and json.total<>invalid)
        channels = CreateObject("roArray", json.total, true)                  
        'print "________ Channels Names __________"
        for x = 0 To json.total-1
            channels[x]  = json.items[x]
            'print channels[x].name
        End for
        'print "______________________________"
        
        if(m.global.hasField("channels"))
            m.global.channels = channels
        else
            m.global.addFields({channels: channels})
        end if
        
        UpdateChannels(channels)
    else
        print "...Channels = Invalid! Error" 
    end if
end sub
'******************************************************
sub UpdateChannels(channels)
    print "...UpdateChannels" 
    m.global.loading = false
    ChannelsContent = createObject("RoSGNode","ContentNode")
    if channels<>invalid
        num = 0
        for each channel in channels
            node = ChannelsContent.createChild("ChannelsGridItemData")
            node.channelID = channel.id
            node.channelNum = num
            node.channelName = channel.name
            node.channelFavorite = channel.favorite
            node.channelLocked = false
            node.channelRecord = channel.record
            
            if ((channel.categoryId = 1 or channel.locked) and m.global.user.categoryId = 1)
                print "CHANNEL LOCKED! " ; channel.name
                node.channelLocked = true
            end if
            
            num++
        end for
    end if
    
    if channels<>invalid and channels.Count()>0
        'm.top.leftLabel.text = m.top.genreName
        m.top.rightLabel.text = "1 "+getTr("of")+" "+channels.Count().tostr()
        m.top.grid.content = ChannelsContent
        
        for i = 0 To channels.Count() - 1
            m.top.grid.content.getChild(i).channelIconUri = m.global.apipath+channels[i].logo
        end for
    else
        m.top.leftLabel.text = ""
        m.top.rightLabel.text = ""
        SetEmptyContent()
    end if
    
end sub
'******************************************************
sub SetLoadingContent()
    ChannelsContent = createObject("RoSGNode","ContentNode")
    node = ChannelsContent.createChild("ChannelsGridItemData")
    node.channelID = -1
    node.channelNum = -1
    node.channelName = getTr("Loading...")
    node.channelIconUri = "pkg:/images/icon_channel_default.png"
    node.channelFavUri = "pkg:/images/empty.png"
    m.top.grid.content = ChannelsContent
end sub

sub SetEmptyContent()
    ChannelsContent = createObject("RoSGNode","ContentNode")
    node = ChannelsContent.createChild("ChannelsGridItemData")
    node.channelID = -1
    node.channelNum = -1
    node.channelName = getTr("No channels")
    node.channelIconUri = "pkg:/images/icon_channel_default.png"
    node.channelFavUri = "pkg:/images/empty.png"
    m.top.grid.content = ChannelsContent
end sub
'******************************************************
Function ChangeChannelFavorite() as Void
    m.curentChannel = m.top.grid.content.getChild(m.top.grid.itemFocused)
    print "ChangeChannelFavorite: ";(m.curentChannel.channelName);" to ";(not m.curentChannel.channelFavorite)
    SetFavorite(m.curentChannel.channelID, (not m.curentChannel.channelFavorite) )
End Function

sub SetFavorite(id, fav)
    print "...SetFavorite id=";id;" to ";fav
    ShowLoadingDialog("Loading...")
    m.request = createObject("roSGNode","PostRequest")
    m.request.uri = m.global.apipath+m.global.apiname+"/tv/ws/Channel?sessionId="+m.global.sessionId
    m.request.params = "id="+id.tostr()+"&favorite="+fav.tostr()
    m.request.observeField("content","OnFavorite")
    m.request.control = "RUN"
end sub

sub OnFavorite()
    HideLoadingDialog()
    print "OnFavorite: ";m.request.content
    json = ParseJSON(m.request.content)
    if(json<>invalid and json.channelId<>invalid)
        for i=0 to m.top.grid.content.getChildCount()-1
            child = m.top.grid.content.getChild(i)
            if child.hasField("channelID") and child.channelID = json.channelId
                print "...OnFavorite before = " ;child.channelFavorite
                child.setField("channelFavorite", (not child.channelFavorite) )
                print "...OnFavorite after = " ;child.channelFavorite
            end if
        end for
    else
        print "...OnFavorite = Invalid! Error" 
    end if    
end sub
'******************************************************
Function OnKeyEvent(key, press) as Boolean    
    result = false
    if press then
        print "ChannelsGrid: OnkeyEvent = ";key
        if key = "options"
            'if m.global.mainScene.VideoPlayer.isPlaying and  (not m.global.mainScene.VideoPlayer.onTop)
            '    m.global.mainScene.VideoPlayer.onTop = true
            'else
            '    ChangeChannelFavorite()
            'end if
            ChangeChannelFavorite()
            return true
        else if key = "OK" or key = "play"
        
        else if key = "left"
            'if m.global.mainScene.VideoPlayer.isPlaying
            '    return true
            'end if
        else if key = "back"
            if m.global.mainScene.VideoPlayer.isPlaying
                m.global.mainScene.VideoPlayer.onTop = true
                return true
            end if
        end if
    end if
    return result
End Function