sub init()
    print "INIT: MovieInfoPanel"
    
    m.top.panelSize = "medium"
    m.top.focusable = false
    m.top.hasNextPanel = false
    m.top.leftOnly = false
    m.top.goBackCount = 1
    
    m.top.createNextPanelOnItemFocus = false
    m.top.selectButtonMovesPanelForward = false

    m.infoTitle = m.top.FindNode("infoTitle")
    m.infoYear =  m.top.FindNode("infoYear")
    m.infoGenre =  m.top.FindNode("infoGenre")
    m.infoDesc =  m.top.FindNode("infoDesc")
    
    m.infoTitle.font = m.global.fonts.bold32
    m.infoTitle.wrap = true
    m.infoTitle.lineSpacing = 0.8
    
    m.infoYear.color = m.global.color.highlight 
    m.infoYear.font = m.global.fonts.bold20
    
    m.infoGenre.color = m.global.color.text2 
    m.infoGenre.font = m.global.fonts.regular16
    
    m.infoDesc.font = m.global.fonts.regular16
    m.infoDesc.lineSpacing = 0.8
    m.top.movieNum = 0
    UpdateInfo()
end sub


sub UpdateInfo()
    print "...UpdateInfo "+m.top.movieNum.ToStr()
    if(m.top.movieNum >= 0 and m.global.movies <> invalid and m.global.movies.Count() > m.top.movieNum)
        movie = m.global.movies[m.top.movieNum]
        if(movie <> invalid)
            m.infoTitle.text = movie.title
            m.infoDesc.text = movie.description.Replace("&apos;", "'")
            m.infoYear.text = movie.year.tostr()
            m.infoGenre = movie.genreString
        endif
    else
        print "...Update Info Error!"
        SetEmpty()
    end if
end sub

sub SetEmpty()
    m.infoTitle.text = ""
    m.infoDesc.text = ""
    m.infoYear.text = ""
    m.infoGenre = ""
end sub