'********** Copyright 2015 Roku Corp.  All Rights Reserved. **********

'************************************************************
'   
'   ROKU APP SKIN SETUP GIUDE
'
'   1. Setup <APP_NAME> in manifest file
'   2. Copy and replace all images from "/images_<APP_NAME>" to "/images folder""
'   3. Uncomment correct init below: "Init<APP_NAME>()" 
'
'************************************************************

sub Main()
    InitTVClub()
    'InitGalaktykaTV()
    'InitRepkaTV()
    showMainScene()
end sub
'*********************************************************** 
sub showMainScene()
    
    screen = CreateObject("roSGScreen")
    m.port = CreateObject("roMessagePort")
    screen.setMessagePort(m.port)
    scene = screen.CreateScene("MainScene")
 
    m.global = screen.getGlobalNode() 
    m.global.addFields({
        apipath: m.apipath,
        apiname: m.apiname,
        vodpath: m.vodpath,
        color: m.color,
        email: m.email,
        appName: m.appName,
        appVersion: "1.3.0b"
    })
    
    screen.show()
    while(true)
        msg = wait(0, m.port)
        msgType = type(msg)
        if msgType = "roSGScreenEvent"
            if msg.isScreenClosed() then return
        end if
    end while
end sub
'*********************************************************** 
sub InitRepkaTV()
    print "INIT: RepkaTV"
    m.apipath = "https://mw.rptvcdn.net"
    m.apiname = "/dapi"
    m.vodpath = "/media"
    m.email = "support@repka.tv"
    m.appName = "Repka TV"
    
    m.color = CreateObject("roAssociativeArray")
    m.color.highlight = "0xeaa90dff"    'gold
    m.color.text = "0xddddddff"         'white
    m.color.text2 = "0xbbbbbbff"        'light gray
    m.color.textFocus = "0x222222ff"    'dark gray
    m.color.text2Focus = "0x000000ff"   'black
end sub
'*********************************************************** 
sub InitGalaktykaTV()
    print "INIT: GalaktykaTV"
    m.apipath = "https://mw.cdnten.com"
    m.apiname = "/dapi"
    m.vodpath = "/media"
    m.email = "support@galaktyka.tv"
    m.appName = "Galaktyka TV"
    
    m.color = CreateObject("roAssociativeArray")
    m.color.highlight = "0xb5e622ff"    'gold
    m.color.text = "0xddddddff"         'white
    m.color.text2 = "0xbbbbbbff"        'light gray
    m.color.textFocus = "0x001935ff"    'dark gray
    m.color.text2Focus = "0x000000ff"   'black
end sub
'*********************************************************** 
sub InitTVClub()
    print "INIT: TVClub"
    m.apipath = "https://mw.cdntvc.com"
    m.apiname = "/dapi"
    m.vodpath = "/media"
    m.email = "support@tvclub.tv"
    m.appName = "TV Club"
    
    m.color = CreateObject("roAssociativeArray")
    m.color.highlight = "0xeaa90dff"    'gold
    m.color.text = "0xddddddff"         'white
    m.color.text2 = "0xbbbbbbff"        'light gray
    m.color.textFocus = "0x222222ff"    'dark gray
    m.color.text2Focus = "0x000000ff"   'black
end sub
'*********************************************************** 